#!/usr/bin/env bash
#
# Copyright (C) 2017 Alyssa Rosenzweig <alyssa@rosenzweig.io>
# Copyright (C) 2017 Leah Rowe <info@minifree.org>
# Copyright (C) 2017 Michael Reed <michael@michaelreed.io>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

[ "x${DEBUG+set}" = 'xset' ] && set -v
set -e

FILE=${1%.md}
ENGFILE=${FILE%.pt}
ENGFILE=${ENGFILE%.pl}
PLFILE="${ENGFILE}.pl"
PTFILE="${ENGFILE}.pt"

TMPFILE=$(mktemp -t transit_www.XXXXXXXXXX)

firstchar=$(head -c 1 ${1})
if [[ "${firstchar}" == "%" ]]; then
    title="$(head -n1 ${1})"
    pagetext="$(tail -n+2 ${1})"
else
    title="$(head -n4 ${1})"
    pagetext="$(tail -n+5 ${1})"
fi

langselect="[English](${ENGFILE}.md) -- [polski](${ENGFILE}.pl.md) -- [Português](${ENGFILE}.pt.md)"

printf "%s\n" "${title}" > "$TMPFILE"
if [[ $FILE != "./fdl-1.3" && $FILE != "fdl-1.3" &&
    $FILE != "./license" && $FILE != "license" ]]; then
    printf "\n%s\n" "${langselect}" >> "$TMPFILE"
fi
printf "\n%s\n" "${pagetext}" >> "$TMPFILE"

OPTS="-T Transit"

if [[ $ENGFILE == "index" || $ENGFILE == "./index" ]]; then
        OPTS="--css /headercenter.css"
else
        if [[ $FILE == $PTFILE ]]; then # portuguese
            if [[ $ENGFILE == *index ]]
            then
                DEST="../index.pt.html"
            else
                DEST="./index.pt.html"
            fi
        elif [[ $FILE == $PLFILE ]]; then # polish
            if [[ $ENGFILE == *index ]]
            then
                DEST="../index.pl.html"
            else
                DEST="./index.pl.html"
            fi
        else # english
            if [[ $ENGFILE == *index ]]
            then
                DEST="../"
            else
                DEST="./"
            fi
        fi
fi

if [[ $ENGFILE != "index" && $ENGFILE != "./index" ]]; then
    if [[ "$FILE" == "$ENGFILE" ]]; then
        RETURN="<strong><a href='/contrib.html#editing-the-website-and-documentation-wiki-style'>Edit this page</a></strong> -- <a href='$DEST'>Back to previous index</a>"
        OPTS="-T Transit"
    elif [[ "$FILE" == "$PTFILE" ]]; then
        RETURN="<strong><a href='/contrib.pt.html#editar-o-website-e-documentação-tal-como-se-tratasse-de-um-wiki'>Editar esta p&aacute;gina</a></strong> -- <a href='$DEST'>Voltar &agrave; p&aacute;gina anterior</a>"
        OPTS="-T Transit"
    elif [[ "$FILE" == "$PLFILE" ]]; then
        RETURN="<strong><a href='/contrib.pl.html#edytowanie-strony-i-dokumentacji-w-stylu-wiki'>Edytuj t&#281 stron&#281</a></strong> -- <a href='$DEST'>Powr&oacute;&#263; do poprzedniej strony</a>"
        OPTS="-T Transit"
    fi
fi

if [[ "$FILE" == "${PTFILE}" ]]; then # portuguese site
    if [[ $FILE != "./fdl-1.3" && $FILE != "fdl-1.3" &&
          $FILE != "./aup.pt"      && $FILE != "aup.pt" ]]; then
        cat footer.pt.md >> "$TMPFILE"
    fi
elif [[ "$FILE" == "${PLFILE}" ]]; then # polish site
    if [[ $FILE != "./fdl-1.3" && $FILE != "fdl-1.3" &&
          $FILE != "./aup.pl"      && $FILE != "aup.pl" ]]; then
        cat footer.pl.md >> "$TMPFILE"
    fi
else
    if [[ $FILE != "./fdl-1.3" && $FILE != "fdl-1.3" &&
          $FILE != "./aup"      && $FILE != "aup" ]]; then
        cat footer.md >> "$TMPFILE"
    fi
fi

# change out .md -> .html
sed -i -e 's/\.md\(#[a-z\-]*\)*)/.html\1)/g' "$TMPFILE"
sed -i -e 's/\.md\(#[a-z\-]*\)*]/.html\1]/g' "$TMPFILE"

# change out .md -> .html
sed -i -e 's/\.md\(#[a-z\-]*\)*)/.html\1)/g' "$TMPFILE"
sed -i -e 's/\.md\(#[a-z\-]*\)*]/.html\1]/g' "$TMPFILE"

# work around issue #2872
TOC=$(grep -q "^x-toc-enable: true$" "$TMPFILE" && printf '%s\n' "--toc --toc-depth=2") || TOC=""

# work around heterogenous pandoc versions
SMART=$(pandoc -v | grep -q '2\.0' || printf '%s\n' "--smart") || SMART=""

# chuck through pandoc
#
# $OPTS must not be quoted, otherwise pandoc interprets '--css /headercenter.css'
# as one argument, when it is actually two.
pandoc $TOC $SMART "$TMPFILE" -s --css /global.css $OPTS \
        --template template.html --metadata return="$RETURN" > "$FILE.html"

# generate section title anchors as [link]
sed -i -e 's_^<h\([123]\) id="\(.*\)">\(.*\)</h\1>_<div class="h"><h\1 id="\2">\3</h\1><a aria-hidden="true" href="#\2">[link]</a></div>_' "$FILE.html"

# clean up temporary filerm -f "$TMPFILE"
